#include <windows.h>
#include "resource.h"
#include "htmlhelp.h"
#pragma comment(lib, "htmlhelp.lib")

DWORD	g_dwCookie;

int CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static DWORD helplist[] = {	IDC_BUTTON1,1,
								IDC_SLIDER1,2,
								IDC_CHECK1,3,
								IDC_CHECK2,-1,
								0,0};	// Ō0ŏI
	static char	pathHelp[MAX_PATH];

	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			GetModuleFileName(NULL, pathHelp, sizeof(pathHelp));
			char *p = strrchr(pathHelp, '\\');
			if(p)
				strcpy(p, "\\DialogHelp.chm::/DialogHelp.txt");
		}
		break;

	case WM_CONTEXTMENU:
		{
			HWND hWnd = (HWND) wParam;
			if(GetDlgCtrlID(hWnd) > 0){
				HtmlHelp(hWnd, pathHelp,
						HH_TP_HELP_CONTEXTMENU, (DWORD)helplist);
			}
		}
		break;

	case WM_HELP:
		{
			LPHELPINFO lphi = (LPHELPINFO) lParam;
			if(lphi->iContextType == HELPINFO_WINDOW){
				HWND hWnd = (HWND)lphi->hItemHandle;
				if(GetDlgCtrlID(hWnd) > 0){
					return HtmlHelp(hWnd, pathHelp,
									HH_TP_HELP_WM_HELP, (DWORD)helplist) != NULL;
				}
			}
			return TRUE;
		}
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;

		case IDCANCEL:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;

		default:
			return FALSE;
		}
		break;

	case WM_CLOSE:
		HtmlHelp(NULL, NULL, HH_UNINITIALIZE, g_dwCookie);
		DestroyWindow(hDlg);
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG  msg;
	HWND hDlg;
	
	hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
	ShowWindow(hDlg, nCmdShow);
	
	HtmlHelp(NULL, NULL, HH_INITIALIZE, g_dwCookie);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(hDlg, &msg))
			continue;
		if(HtmlHelp(NULL, NULL, HH_PRETRANSLATEMESSAGE, (DWORD)&msg))
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
